require "food"

love.graphics.setDefaultFilter("nearest","nearest")
--defines directions and there opposites
directions = {
	left = {
		movement = function (snake) snake.x = snake.x - snake.w end,
		opposite = "right"
	},
	right = {
		movement = function (snake) snake.x = snake.x + snake.w end,
		opposite = "left"
	},
	down = {
		movement = function (snake) snake.y = snake.y + snake.h end,
		opposite = "up"
	},
	up = {
		movement = function (snake) snake.y = snake.y - snake.h end,
		opposite = "down"
	}
}
--your in game when you start
gamestate = "game"
delay = 0.50

function love.load()
	food:new()
	pointFont = love.graphics.newFont("fonts/Call of Ops Duty.otf", 25)
	gameOverFont = love.graphics.newFont("fonts/Squares Bold Free.otf", 50)
	snake = {
		x = 400,
		y = 300,
		w = 20,
		h = 20,
		direction, nextdirection = "left" --start direction
	}
	seconds = 0
end

function love.keypressed(key, scancode, isrepeat)
	if directions[key] ~= nil and snake.direction ~= directions[key].opposite then
		snake.nextdirection = key --moveing
	end
end

function love.update(dt)
	food:update(dt)
	seconds = seconds + dt -------------------------------------------
	if seconds >= delay then       --makes the snake "jump"--
		seconds = seconds - delay---------------------------------------
		snake.direction = snake.nextdirection
		directions[snake.direction].movement(snake)
	end
	--boundaries, makes the player loose
	if snake.x < 0 then
		snake.x = 0
		gamestate = "gameover"
	end
	if snake.y < 0 then
		snake.y = 0
		gamestate = "gameover"
	end
	if snake.x + snake.w > 800 then
		snake.x = 800 - snake.w
		gamestate = "gameover"
	end
	if snake.y + snake.h > 600 then
		snake.y = 600 - snake.h
		gamestate = "gameover"
	end
end

function love.draw()
	food:draw()
	love.graphics.setBackgroundColor(41, 170, 226)
	love.graphics.setColor(232, 74, 153)
	if gamestate == "game" then
		love.graphics.rectangle("fill", snake.x, snake.y, snake.w, snake.h)
	elseif gamestate == "gameover" then --dont sraw the player if its gameover
		love.graphics.setFont(gameOverFont)
		love.graphics.setColor(255, 0, 0)
		love.graphics.print("Game Over!", 210, 150, 0, 1, 3)
	end
end
